// <![CDATA[
dojo.require("dojo.parser");
dojo.require("dijit.Dialog");

// changeable options
var csEasyTubeGalleryPrevLinkText_%id=id% = "%id=prevLinkText%";
var csEasyTubeGalleryNextLinkText_%id=id% = "%id=nextLinkText%";
var csEasyTubeGalleryGalleryNumRows_%id=id% = "%id=maxRows%";
var csEasyTubeGalleryGalleryNumColumns_%id=id% = "%id=maxCols%";
var csEasyTubeGalleryGallerywidthOfThumbnails_%id=id% = "%id=thumbnailWidth%";
var csEasyTubeGalleryAutoplay_%id=id% = "%id=autoplaySetting%";
var csEasyTubeGalleryEnlargeDialogCloseTab_%id=id% = "%id=enlargeVideoDialogCloseText%";

// for fade in
var csEasyTubeGalleryFadeArgs_%id=id% = {
	node: "csEasyTubeGalleryGalleryContainer_%id=id%",
	duration: %id=fadeInTime%
};

// event handles
var csEasyTubeGalleryPrevHandle_%id=id% = false;
var csEasyTubeGalleryNextHandle_%id=id% = false;	

// store the json.data inside a variable, for easy reference
var cseasygalleryjson_%id=id% = { %id=json% };
var csEasyTubeGalleryGalleryElements_%id=id% = new Array();

dojo.addOnLoad(function() {
	dojo.query("body").addClass("tundra");
	
	if (!dijit.byId("csEasyTubeGalleryEnlarge_%id=id%")) {
		dojo.parser.parse();
	}
	
	// if the video is playing in the dialog box, and the dialog box is closed, we want the video to stop playing.
	dojo.connect(dijit.byId("csEasyTubeGalleryEnlarge_%id=id%"), "hide", function(e) {
		var currentContents = dijit.byId("csEasyTubeGalleryEnlarge_%id=id%").innerHTML;
		dijit.byId("csEasyTubeGalleryEnlarge_%id=id%").setContent(currentContents);
//		if (dojo.isIE) {
//			dojo.style(dojo.byId("mod_aytube4js_youtube"), "display", "block");			
//		}
	});
	

	for (i = 0; i < cseasygalleryjson_%id=id%.count; i++) {
		csEasyTubeGalleryGalleryElements_%id=id%[i] = cseasygalleryjson_%id=id%.data[i];
	}

	dojo.byId("csEasyTubeGalleryGalleryNav_%id=id%").innerHTML = "";
	dojo.byId("csEasyTubeGalleryGalleryFirstElementCounter_%id=id%").value = 0;
	dojo.byId("csEasyTubeGalleryGalleryLastElementCounter_%id=id%").value = 0;
	csEasyTubeGalleryShowGalleryNextPage_%id=id%();	
});

function csEasyTubeGalleryShowGalleryNextPage_%id=id%() 
{
	var currentRowCount = 0;
	var currentColumnCount = 0;
	var randomnumber=Math.random();
	var csEasyTubeGalleryGalleryOutput = "<br /><table id=\"csEasyTubeGalleryGallery_" + randomnumber + "\" class=\"csEasyTubeGalleryTable\">";
	var numberOfElementsShown = dojo.byId("csEasyTubeGalleryGalleryLastElementCounter_%id=id%").value;
	var csEasyTubeGalleryGalleryPrevNavigation = "";
	var csEasyTubeGalleryGalleryNextNavigation = "";

	var firstElementRecorded = false;

	for (i = 0; i < csEasyTubeGalleryGalleryElements_%id=id%.length; i++) {
		if (numberOfElementsShown > 0) {
			if (numberOfElementsShown > i) {
				continue;
			}
		}	

		// start a new row if the number of elements column-wise is too many
		if (currentColumnCount >= csEasyTubeGalleryGalleryNumColumns_%id=id%) {
			csEasyTubeGalleryGalleryOutput += "</tr>";
			csEasyTubeGalleryGalleryOutput += "<tr>";
			currentColumnCount = 0;
			currentRowCount++;
		}

		// record the first element showed 
		if (!firstElementRecorded) {
			dojo.byId("csEasyTubeGalleryGalleryFirstElementCounter_%id=id%").value = i;
			firstElementRecorded = true;
		}
		// stop this loop if we've reached > number of rows allowed
		if (currentRowCount >= csEasyTubeGalleryGalleryNumRows_%id=id%) {
			// record where the current element is.
			// when we resume we will use this number as the start (for next page)
			numberOfElementsShown = i;
			// check if we need to show the "Prev" link
			if (i > csEasyTubeGalleryGalleryNumRows_%id=id% * csEasyTubeGalleryGalleryNumColumns_%id=id%){
				csEasyTubeGalleryGalleryPrevNavigation = "<a href='#' id='csEasyTubeGalleryGalleryPrevLink_%id=id%'>" + csEasyTubeGalleryURL_%id=id%.decode(csEasyTubeGalleryPrevLinkText_%id=id%) + "</a> - ";
			}
			if (i <= csEasyTubeGalleryGalleryElements_%id=id%.length - 1) {
				csEasyTubeGalleryGalleryNextNavigation = "<a href='#' id='csEasyTubeGalleryGalleryNextLink_%id=id%'>" + csEasyTubeGalleryURL_%id=id%.decode(csEasyTubeGalleryNextLinkText_%id=id%) + "</a>";
			}
			break;
		}
		else if (i == csEasyTubeGalleryGalleryElements_%id=id%.length - 1) {
			if (csEasyTubeGalleryGalleryElements_%id=id%.length > csEasyTubeGalleryGalleryNumRows_%id=id% * csEasyTubeGalleryGalleryNumColumns_%id=id%) {
				csEasyTubeGalleryGalleryPrevNavigation += "<a href='#' id='csEasyTubeGalleryGalleryPrevLink_%id=id%'>" + csEasyTubeGalleryURL_%id=id%.decode(csEasyTubeGalleryPrevLinkText_%id=id%) + "</a>";	
			}
		}	
				
		csEasyTubeGalleryGalleryOutput += "<td><a href='#' onclick='csEasyTubeGalleryShowEnlargedVideo_%id=id%(\"" + csEasyTubeGalleryGalleryElements_%id=id%[i].title + "\", \"" + csEasyTubeGalleryGalleryElements_%id=id%[i].videoURL + "\"); return false;'><img class=\"csEasyTubeGalleryThumbnail\" src=\"" + csEasyTubeGalleryGalleryElements_%id=id%[i].imageURL + "\" style=\"width: " + csEasyTubeGalleryGallerywidthOfThumbnails_%id=id% + "px;\" title=\"" + csEasyTubeGalleryURL_%id=id%.decode(csEasyTubeGalleryGalleryElements_%id=id%[i].title) + "\" /></a></td>";
		currentColumnCount++;
	}

	csEasyTubeGalleryGalleryOutput += "</table>";
	// now add a hidden var here to record element position
	dojo.byId("csEasyTubeGalleryGalleryLastElementCounter_%id=id%").value = numberOfElementsShown;
	
	// always hide the ajax-loader
	dojo.style("csEasyTubeGalleryLoadingGif_%id=id%", "display", "none");

	// for fade in later
	dojo.style("csEasyTubeGalleryGalleryContainer_%id=id%", "opacity", "0");

	// now write to dom			
	dojo.byId("csEasyTubeGalleryGalleryNav_%id=id%").innerHTML = csEasyTubeGalleryGalleryPrevNavigation + csEasyTubeGalleryGalleryNextNavigation;
	dojo.byId("csEasyTubeGalleryGalleryContainer_%id=id%").innerHTML = csEasyTubeGalleryGalleryOutput;

	// fade in
	dojo.fadeIn(csEasyTubeGalleryFadeArgs_%id=id%).play();
	

	// set up the event handlers
	if (csEasyTubeGalleryPrevHandle_%id=id%) {
		dojo.disconnect(csEasyTubeGalleryPrevHandle_%id=id%);
	}
	if (dojo.byId("csEasyTubeGalleryGalleryPrevLink_%id=id%")) {
		csEasyTubeGalleryPrevHandle_%id=id% = dojo.connect(dojo.byId("csEasyTubeGalleryGalleryPrevLink_%id=id%"), "onclick", function(evt) 
			{ 
				evt.preventDefault();
				csEasyTubeGalleryShowGalleryPrevPage_%id=id%(); 
			} 
		);
	}
	if (csEasyTubeGalleryNextHandle_%id=id%) {
		dojo.disconnect(csEasyTubeGalleryNextHandle_%id=id%);
	}
	if (dojo.byId("csEasyTubeGalleryGalleryNextLink_%id=id%")) {
		csEasyTubeGalleryNextHandle_%id=id% = dojo.connect(dojo.byId("csEasyTubeGalleryGalleryNextLink_%id=id%"), "onclick", function(evt) 
			{ 
				evt.preventDefault();
				csEasyTubeGalleryShowGalleryNextPage_%id=id%(); 
			} 
		);
	}

	dojo.parser.parse("csEasyTubeGalleryGallery_" + randomnumber);
}

function csEasyTubeGalleryShowGalleryPrevPage_%id=id%() 
{
	var currentRowCount = 0;
	var currentColumnCount = 0;
	var randomnumber=Math.random();
	var csEasyTubeGalleryGalleryOutput = "<br /><table id=\"csEasyTubeGalleryGallery_" + randomnumber + "\" class=\"csEasyTubeGalleryTable\">";
	var numberOfElementsShown = dojo.byId("csEasyTubeGalleryGalleryFirstElementCounter_%id=id%").value;
	var csEasyTubeGalleryGalleryPrevNavigation = "";
	var csEasyTubeGalleryGalleryNextNavigation = "";

	var maxNumberOfElementsToShow = csEasyTubeGalleryGalleryNumRows_%id=id% * csEasyTubeGalleryGalleryNumColumns_%id=id%;

	var firstElementRecorded = false;

	for (i = 0; i < csEasyTubeGalleryGalleryElements_%id=id%.length; i++) 
	{
		if (i < numberOfElementsShown - maxNumberOfElementsToShow) {
				continue;
		}	
		// record the first element showed 
		if (!firstElementRecorded) {
			dojo.byId("csEasyTubeGalleryGalleryFirstElementCounter_%id=id%").value = i;
			firstElementRecorded = true;
		}

		// start a new row if the number of elements column-wise is too many
		if (currentColumnCount >= csEasyTubeGalleryGalleryNumColumns_%id=id%) {
			csEasyTubeGalleryGalleryOutput += "</tr>";
			csEasyTubeGalleryGalleryOutput += "<tr>";
			currentColumnCount = 0;
			currentRowCount++;
		}
		// stop this loop if we've reached > number of rows allowed
		if (currentRowCount >= csEasyTubeGalleryGalleryNumRows_%id=id%) {
			// record where the current element is.
			// when we resume we will use this number as the start (for next page)
			numberOfElementsShown = i;
			// check if we need to show the "Prev" link
			if (i > csEasyTubeGalleryGalleryNumRows_%id=id% * csEasyTubeGalleryGalleryNumColumns_%id=id%){
				csEasyTubeGalleryGalleryPrevNavigation += "<a href='#' id='csEasyTubeGalleryGalleryPrevLink_%id=id%'>" + csEasyTubeGalleryURL_%id=id%.decode(csEasyTubeGalleryPrevLinkText_%id=id%) + "</a> - ";
			}
			if (i <= csEasyTubeGalleryGalleryElements_%id=id%.length - 1) {
				csEasyTubeGalleryGalleryNextNavigation += "<a href='#' id='csEasyTubeGalleryGalleryNextLink_%id=id%'>" + csEasyTubeGalleryURL_%id=id%.decode(csEasyTubeGalleryNextLinkText_%id=id%) + "</a>";
			}
			break;
		}
		else if (i == csEasyTubeGalleryGalleryElements_%id=id%.length - 1) {
			csEasyTubeGalleryGalleryPrevNavigation += "<a href='#' id='csEasyTubeGalleryGalleryPrevLink_%id=id%'>" + csEasyTubeGalleryURL_%id=id%.decode(csEasyTubeGalleryPrevLinkText_%id=id%) + "</a> ";	
		}	
		csEasyTubeGalleryGalleryOutput += "<td><a href='#' onclick='csEasyTubeGalleryShowEnlargedVideo_%id=id%(\"" + csEasyTubeGalleryGalleryElements_%id=id%[i].title + "\", \"" + csEasyTubeGalleryGalleryElements_%id=id%[i].videoURL + "\");'><img class=\"csEasyTubeGalleryThumbnail\" src=\"" + csEasyTubeGalleryGalleryElements_%id=id%[i].imageURL + "\" style=\"width: " + csEasyTubeGalleryGallerywidthOfThumbnails_%id=id% + "px;\" title=\"" + csEasyTubeGalleryURL_%id=id%.decode(csEasyTubeGalleryGalleryElements_%id=id%[i].title) + "\" /></a></td>";

		currentColumnCount++;
	}
	csEasyTubeGalleryGalleryOutput += "</table>";
	// now add a hidden var here to record element position
	dojo.byId("csEasyTubeGalleryGalleryLastElementCounter_%id=id%").value = numberOfElementsShown;
	
	// for fade in later
	dojo.style("csEasyTubeGalleryGalleryContainer_%id=id%", "opacity", "0");
	
	// now write to dom
	dojo.byId("csEasyTubeGalleryGalleryNav_%id=id%").innerHTML = csEasyTubeGalleryGalleryPrevNavigation + csEasyTubeGalleryGalleryNextNavigation;
	dojo.byId("csEasyTubeGalleryGalleryContainer_%id=id%").innerHTML = csEasyTubeGalleryGalleryOutput; 

	// fade in
	dojo.fadeIn(csEasyTubeGalleryFadeArgs_%id=id%).play();


	// set up the event handlers
	if (csEasyTubeGalleryPrevHandle_%id=id%) {
		dojo.disconnect(csEasyTubeGalleryPrevHandle_%id=id%);
	}
	if (dojo.byId("csEasyTubeGalleryGalleryPrevLink_%id=id%")) {
		csEasyTubeGalleryPrevHandle_%id=id% = dojo.connect(dojo.byId("csEasyTubeGalleryGalleryPrevLink_%id=id%"), "onclick", function(evt) 
			{ 
				evt.preventDefault();
				csEasyTubeGalleryShowGalleryPrevPage_%id=id%(); 
			} 
		);
	}
	if (csEasyTubeGalleryNextHandle_%id=id%) {
		dojo.disconnect(csEasyTubeGalleryNextHandle_%id=id%);
	}
	if (dojo.byId("csEasyTubeGalleryGalleryNextLink_%id=id%")) {
		csEasyTubeGalleryNextHandle_%id=id% = dojo.connect(dojo.byId("csEasyTubeGalleryGalleryNextLink_%id=id%"), "onclick", function(evt) 
			{ 
				evt.preventDefault();
				csEasyTubeGalleryShowGalleryNextPage_%id=id%(); 
			} 
		);
	}

	dojo.parser.parse("csEasyTubeGalleryGallery_" + randomnumber);
}
	
function csEasyTubeGalleryShowEnlargedVideo_%id=id%(title, videoToDisplay)
{
	dijit.byId("csEasyTubeGalleryEnlarge_%id=id%").titleNode.innerHTML = csEasyTubeGalleryURL_%id=id%.decode(title);
	var widthOfVideoToShow = %id=widthOfVideoWhenPlaying%;
	var aspectRatioOfVideo = "%id=videoAspectRatio%";
	var heightOfVideoToShow = 0.81 * widthOfVideoToShow;
	if (aspectRatioOfVideo == "16:9") {
		heightOfVideoToShow = 0.56 * widthOfVideoToShow + 25;
	}
	var useHTML5 = %id=useHTML5%;	
	
	var codeOfVideoToShow = '';
	
	if (useHTML5) {
		codeOfVideoToShow = '<iframe class="youtube-player" type="text/html" width="' + widthOfVideoToShow + '" height="' + heightOfVideoToShow + '" src="http://www.youtube.com/embed/' + videoToDisplay + '?rel=0%id=forceHDEmbed%&amp;autoplay=' + csEasyTubeGalleryAutoplay_%id=id% + '" frameborder="0"></iframe>';
	}
	else {
		codeOfVideoToShow = '<object width="' + widthOfVideoToShow + '" height="' + heightOfVideoToShow + '"><param name="movie" value="http://www.youtube.com/v/' + videoToDisplay + '?fs=1%id=forceHDEmbed%&amp;enablejsapi=1&amp;rel=0&amp;autoplay=' + csEasyTubeGalleryAutoplay_%id=id% + '"></param><param name="allowFullScreen" value="true"></param><param name="allowscriptaccess" value="always"></param><embed src="http://www.youtube.com/v/' + videoToDisplay + '?f=standard%id=forceHDEmbed%&amp;app=youtube_gdata&amp;fs=1&amp;enablejsapi=1&amp;rel=0&amp;autoplay=' + csEasyTubeGalleryAutoplay_%id=id% + '" type="application/x-shockwave-flash" allowscriptaccess="always" allowfullscreen="true" width="' + widthOfVideoToShow + '" height="' + heightOfVideoToShow + '"></embed></object>';
	}
	
	codeOfVideoToShow += "<br /><a href='#' id='csEasyTubeGalleryEnlarge_%id=id%DialogClose' onclick='dijit.byId(\"csEasyTubeGalleryEnlarge_%id=id%\").hide(); return false;'>" + csEasyTubeGalleryURL_%id=id%.decode(csEasyTubeGalleryEnlargeDialogCloseTab_%id=id%) + "</a>";

	dijit.byId("csEasyTubeGalleryEnlarge_%id=id%").setContent(codeOfVideoToShow);
	dijit.byId("csEasyTubeGalleryEnlarge_%id=id%").show();

	return false;
}


// video controls
// function that is called when the player is ready
function onYouTubePlayerReady(playerId) {
}

var csEasyTubeGalleryURL_%id=id% = 
{
// credit to http://www.webtoolkit.info/javascript-url-decode-encode.html for this.
	// public method for url encoding
	encode : function (string) {
		return escape(this._utf8_encode(string));
	},

	// public method for url decoding
	decode : function (string) {
		return this._utf8_decode(unescape(string));
	},

	// private method for UTF-8 encoding
	_utf8_encode : function (string) {
		string = string.replace(/\r\n/g,"\n");
		var utftext = "";

		for (var n = 0; n < string.length; n++) {

			var c = string.charCodeAt(n);

			if (c < 128) {
				utftext += String.fromCharCode(c);
			}
			else if((c > 127) && (c < 2048)) {
				utftext += String.fromCharCode((c >> 6) | 192);
				utftext += String.fromCharCode((c & 63) | 128);
			}
			else {
				utftext += String.fromCharCode((c >> 12) | 224);
				utftext += String.fromCharCode(((c >> 6) & 63) | 128);
				utftext += String.fromCharCode((c & 63) | 128);
			}

		}

		return utftext;
	},

	// private method for UTF-8 decoding
	_utf8_decode : function (utftext) {
		var string = "";
		var i = 0;
		var c = c1 = c2 = 0;

		while ( i < utftext.length ) {

			c = utftext.charCodeAt(i);

			if (c < 128) {
				string += String.fromCharCode(c);
				i++;
			}
			else if((c > 191) && (c < 224)) {
				c2 = utftext.charCodeAt(i+1);
				string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
				i += 2;
			}
			else {
				c2 = utftext.charCodeAt(i+1);
				c3 = utftext.charCodeAt(i+2);
				string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
				i += 3;
			}

		}

		return string;
	}

}
// ]]>